exports.generate = async function() {
	/* START REQUEST PATHFILE */
	const prompts = require('prompts');
	let response = 'test.csv';
	
	(async () => {
		response = await prompts({
			type: 'text',
			name: 'pathfile',
			message: 'Pathfile to process: '
		});

		console.log(response);
		
		/* START READ CSV FILE */
		const csvFilePath = response.pathfile;
		const csv = require('csvtojson');
		const XMLWriter = require('xml-writer');
		let json;

		csv()
		.fromFile(csvFilePath)
		.then((jsonObj)=>{
			console.log(jsonObj);
			json = jsonObj;
			/**
			 * [
			 * 	{a:"1", b:"2", c:"3"},
			 * 	{a:"4", b:"5". c:"6"}
			 * ]
			 */
			 
			/* START ELABORATING JSON */
			let resourceMap = new Map();
			json.forEach(j => {
				if (j.resourceName != '' && j.resourceName != null && j.resourceType != '' && j.resourceType != null) {
					if (resourceMap.get(j.resourceType) === undefined)
						resourceMap.set(j.resourceType, [j.resourceName]);
					else if (!resourceMap.get(j.resourceType).includes(j.resourceName))
						resourceMap.set(j.resourceType, resourceMap.get(j.resourceType).concat([j.resourceName]));
				}
			});
			
			/* START GENERATING XML FILE */
			const fs = require('fs');
			let xw = new XMLWriter;
			let ws = fs.createWriteStream('package.xml');
			ws.on('close', function() {
				console.log('\n\nFile is ready. Enjoy!');
			});
			xw = new XMLWriter(false, function(string, encoding) {
					ws.write(string, encoding);
			});
			xw.startDocument('1.0', 'UTF-8').startElement('Package').writeAttribute('xmlns', 'http://soap.sforce.com/2006/04/metadata');
			
			for (let [key , value] of resourceMap.entries()) {
				// key => Type ; value => [Resources]
				xw.startElement('types');
				value.forEach(v => {
					xw.writeElement('members', v);
				});
				xw.writeElement('name', key);
				xw.endElement();
			}
			// VERSION TAG
			xw.writeElement('version', '40.0').endElement();
			// CLOSE Package TAG
			xw.endElement();
			
			ws.end();

			// GENERATING FOLDER AND MOVE FILE INSIDE
			const makeDir = require('make-dir');
 
			(async () => {
				const path = await makeDir('target');
				const moveFile = require('move-file');
 
				(async () => {
					await moveFile('package.xml', 'target/package.xml');
					await moveFile(csvFilePath, 'target/source.csv');
				})();
			})();

		});
	})();
	
}